﻿local Engine, Api, Locale, Settings = unpack(Immersive)

local Default = Engine:GetModule("Default")

-- Registers the element.
function Default:RegisterOrderHallCommandBar()
	local settings = Settings:Get(self.Name).Elements["OrderHallCommandBar"]
	local orderHall = Api:RegisterElement("OrderHallCommandBar", settings)
	
	orderHall.Animation:RegisterEvent("ADDON_LOADED")
	orderHall.Animation:RegisterEvent("PLAYER_ENTERING_WORLD")
	orderHall.Animation:SetScript("OnEvent", function(frame, event, name)
		if event == "PLAYER_ENTERING_WORLD" or (event == "ADDON_LOADED" and name == "Blizzard_OrderHallUI") then
			if OrderHallCommandBar ~= nil then
				-- Add frames
				orderHall:AddFrame(OrderHallCommandBar)
	
				-- Add conditions
				orderHall:AddConditionRange(settings.Conditions)
	
				-- Add hotspots
				orderHall:AddHotspot(OrderHallCommandBar:GetRect())

				orderHall:Reset()
				orderHall.Animation:UnregisterEvent("ADDON_LOADED")
			end
		end
	end)
end

-- Unregisters the element.
function Default:UnregisterOrderHallCommandBar()
	Api:UnregisterElement("OrderHallCommandBar")
end